#include <hxcpp.h>

#ifndef INCLUDED_snow_types_InputEventType
#include <snow/types/InputEventType.h>
#endif
#ifndef INCLUDED_snow_types_InputEvents
#include <snow/types/InputEvents.h>
#endif
namespace snow{
namespace types{

Void InputEvents_obj::__construct()
{
	return null();
}

//InputEvents_obj::~InputEvents_obj() { }

Dynamic InputEvents_obj::__CreateEmpty() { return  new InputEvents_obj; }
hx::ObjectPtr< InputEvents_obj > InputEvents_obj::__new()
{  hx::ObjectPtr< InputEvents_obj > result = new InputEvents_obj();
	result->__construct();
	return result;}

Dynamic InputEvents_obj::__Create(hx::DynamicArray inArgs)
{  hx::ObjectPtr< InputEvents_obj > result = new InputEvents_obj();
	result->__construct();
	return result;}

int InputEvents_obj::ie_unknown;

int InputEvents_obj::ie_key;

int InputEvents_obj::ie_mouse;

int InputEvents_obj::ie_touch;

int InputEvents_obj::ie_joystick;

int InputEvents_obj::ie_controller;

::snow::types::InputEventType InputEvents_obj::typed( int type){
	HX_STACK_FRAME("snow.types.InputEvents","typed",0x2c4ab03f,"snow.types.InputEvents.typed","snow/types/Types.hx",632,0x72b41ce7)
	HX_STACK_ARG(type,"type")
	HX_STACK_LINE(634)
	if (((type == ::snow::types::InputEvents_obj::ie_unknown))){
		HX_STACK_LINE(634)
		return ::snow::types::InputEventType_obj::unknown;
	}
	HX_STACK_LINE(635)
	if (((type == ::snow::types::InputEvents_obj::ie_key))){
		HX_STACK_LINE(635)
		return ::snow::types::InputEventType_obj::key;
	}
	HX_STACK_LINE(636)
	if (((type == ::snow::types::InputEvents_obj::ie_mouse))){
		HX_STACK_LINE(636)
		return ::snow::types::InputEventType_obj::mouse;
	}
	HX_STACK_LINE(637)
	if (((type == ::snow::types::InputEvents_obj::ie_touch))){
		HX_STACK_LINE(637)
		return ::snow::types::InputEventType_obj::touch;
	}
	HX_STACK_LINE(638)
	if (((type == ::snow::types::InputEvents_obj::ie_joystick))){
		HX_STACK_LINE(638)
		return ::snow::types::InputEventType_obj::joystick;
	}
	HX_STACK_LINE(639)
	if (((type == ::snow::types::InputEvents_obj::ie_controller))){
		HX_STACK_LINE(639)
		return ::snow::types::InputEventType_obj::controller;
	}
	HX_STACK_LINE(641)
	return ::snow::types::InputEventType_obj::unknown;
}


STATIC_HX_DEFINE_DYNAMIC_FUNC1(InputEvents_obj,typed,return )


InputEvents_obj::InputEvents_obj()
{
}

Dynamic InputEvents_obj::__Field(const ::String &inName,bool inCallProp)
{
	switch(inName.length) {
	case 5:
		if (HX_FIELD_EQ(inName,"typed") ) { return typed_dyn(); }
		break;
	case 6:
		if (HX_FIELD_EQ(inName,"ie_key") ) { return ie_key; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"ie_mouse") ) { return ie_mouse; }
		if (HX_FIELD_EQ(inName,"ie_touch") ) { return ie_touch; }
		break;
	case 10:
		if (HX_FIELD_EQ(inName,"ie_unknown") ) { return ie_unknown; }
		break;
	case 11:
		if (HX_FIELD_EQ(inName,"ie_joystick") ) { return ie_joystick; }
		break;
	case 13:
		if (HX_FIELD_EQ(inName,"ie_controller") ) { return ie_controller; }
	}
	return super::__Field(inName,inCallProp);
}

Dynamic InputEvents_obj::__SetField(const ::String &inName,const Dynamic &inValue,bool inCallProp)
{
	switch(inName.length) {
	case 6:
		if (HX_FIELD_EQ(inName,"ie_key") ) { ie_key=inValue.Cast< int >(); return inValue; }
		break;
	case 8:
		if (HX_FIELD_EQ(inName,"ie_mouse") ) { ie_mouse=inValue.Cast< int >(); return inValue; }
		if (HX_FIELD_EQ(inName,"ie_touch") ) { ie_touch=inValue.Cast< int >(); return inValue; }
		break;
	case 10:
		if (HX_FIELD_EQ(inName,"ie_unknown") ) { ie_unknown=inValue.Cast< int >(); return inValue; }
		break;
	case 11:
		if (HX_FIELD_EQ(inName,"ie_joystick") ) { ie_joystick=inValue.Cast< int >(); return inValue; }
		break;
	case 13:
		if (HX_FIELD_EQ(inName,"ie_controller") ) { ie_controller=inValue.Cast< int >(); return inValue; }
	}
	return super::__SetField(inName,inValue,inCallProp);
}

void InputEvents_obj::__GetFields(Array< ::String> &outFields)
{
	super::__GetFields(outFields);
};

static ::String sStaticFields[] = {
	HX_CSTRING("ie_unknown"),
	HX_CSTRING("ie_key"),
	HX_CSTRING("ie_mouse"),
	HX_CSTRING("ie_touch"),
	HX_CSTRING("ie_joystick"),
	HX_CSTRING("ie_controller"),
	HX_CSTRING("typed"),
	String(null()) };

#if HXCPP_SCRIPTABLE
static hx::StorageInfo *sMemberStorageInfo = 0;
#endif

static ::String sMemberFields[] = {
	String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(InputEvents_obj::__mClass,"__mClass");
	HX_MARK_MEMBER_NAME(InputEvents_obj::ie_unknown,"ie_unknown");
	HX_MARK_MEMBER_NAME(InputEvents_obj::ie_key,"ie_key");
	HX_MARK_MEMBER_NAME(InputEvents_obj::ie_mouse,"ie_mouse");
	HX_MARK_MEMBER_NAME(InputEvents_obj::ie_touch,"ie_touch");
	HX_MARK_MEMBER_NAME(InputEvents_obj::ie_joystick,"ie_joystick");
	HX_MARK_MEMBER_NAME(InputEvents_obj::ie_controller,"ie_controller");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatics(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(InputEvents_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(InputEvents_obj::ie_unknown,"ie_unknown");
	HX_VISIT_MEMBER_NAME(InputEvents_obj::ie_key,"ie_key");
	HX_VISIT_MEMBER_NAME(InputEvents_obj::ie_mouse,"ie_mouse");
	HX_VISIT_MEMBER_NAME(InputEvents_obj::ie_touch,"ie_touch");
	HX_VISIT_MEMBER_NAME(InputEvents_obj::ie_joystick,"ie_joystick");
	HX_VISIT_MEMBER_NAME(InputEvents_obj::ie_controller,"ie_controller");
};

#endif

Class InputEvents_obj::__mClass;

void InputEvents_obj::__register()
{
	hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.types.InputEvents"), hx::TCanCast< InputEvents_obj> ,sStaticFields,sMemberFields,
	&__CreateEmpty, &__Create,
	&super::__SGetClass(), 0, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatics
#endif
#ifdef HXCPP_SCRIPTABLE
    , sMemberStorageInfo
#endif
);
}

void InputEvents_obj::__boot()
{
	ie_unknown= (int)0;
	ie_key= (int)1;
	ie_mouse= (int)2;
	ie_touch= (int)3;
	ie_joystick= (int)4;
	ie_controller= (int)5;
}

} // end namespace snow
} // end namespace types
